## hildon-desktop 0.0.35-1

=== debian/changelog ===
hildon-desktop (1:0.0.35-1) sardine; urgency=low

  * libhildondesktop/hildon-desktop-panel-expandable.c:
  (hildon_desktop_panel_expandable_hide_extension),
  (hildon_desktop_panel_close_fullscreen),
  (hildon_desktop_panel_expandable_constructor):
  - Check the fullscreen signal to close the extension panel.
  Fixes: NB#68729

  * data/top-panel.conf.in, data/bottom-panel.conf.in: added
  default panel configurations for hildon-desktop
  * data/desktop.conf.in: change default layout to 2 panels,
  bottom and top
  * data/home.conf.in: removed maemo-specific plugins
  * data/tasknavigator.conf.in, data/statusbar.conf.in: removed
  maemo-specific panels
  * data/applications.menu: Removed maemo-specific applications

  * libhildondesktop/hildon-desktop-popup-menu.c: do not paint
  the ViewPorts as their background already have the right color

  * src/hd-switcher-menu.c (hd_switcher_menu_refresh_application_items,
  hd_switcher_menu_refresh_notification_items,
  hd_switcher_menu_constructor, hd_switcher_menu_hw_cb,
  hd_switcher_menu_osso_init,
  hd_switcher_menu_create_notifications_menu,
  hd_switcher_menu_changed_info_cb,
  hd_switcher_menu_notification_deleted_cb,
  hd_switcher_menu_notification_changed_cb): deactivate all blinking
  from switcher menu when hardware signal for system inactivity is 
  sent. Fixes: NB#60063.

  * src/hd-panel-window-dialog.c:
  - when using XComposite, redirect the window to avoid
  flicking when a menu or application comes on top
  * libhildondesktop/hildon-desktop-panel-window-composite.c:
  - cache the theme pattern painted on top of the home background
  to speed up painting

  * libhildondesktop/hildon-desktop-panel-expandable.c:
  (hildon_desktop_panel_expandable_add_arrow):
  - Queue item to get the theme. Fixes: NB#66675

  * src/hd-desktop.c: (hd_desktop_plugin_list_to_conf):
  - Reverse list of plugins in order to not get reversed plugins in
  statusbar when installing/uninstalling an applet. 
  Fixes: NB#66911

  * libhildonwm/hd-wm.[ch]: (hd_wm_switch_instance_current_application):
  - Added new method to switch to prev/next application. Suggested by
  Horace Li from Intel.

  * libhildondesktop/hildon-desktop-panel-window-composite.c:
  - fixed invalidation of the window area when the desktop window
  changes

  * src/hd-home-window.c: save the container when an applet is
  removed, except when we are running the Select applets dialog,
  in which case HDDesktop does it for us

  * libhildondesktop/hildon-home-area.c: signal a layout change
  when placing or removing a widget

  * libhildondesktop/hildon-desktop-picture.[ch]:
  - added _picture_from_color
  * background-manager/background-manager.{c,h,xml.in}:
  - pass the picture identifier as argument, the picture is now
  expected to be created on client side
  - don't pass the background color any longer
  * background-manager/hbm-background.[ch]:
  - added picture property
  - do not create a new picture but paint on the provided one
  * src/hd-home-background.c: create a picture before passing
  it to the background manager.
  Fixes: NB#66928

  * libhildondesktop/hildon-home-area.[ch]: removed the "batch_add"
  optimization as it makes the code too complex
  * src/hd-home-window.c: do not call set_batch_add

  * libhildonwm (hd_wm_activate_window): correctly activate applications
  menu through keyboard shortcut. Fixes: NB#55569.

  * src/hd-switcher-menu.c (hd_switcher_menu_changed_info_cb): fix
  regression bug on defining whether to blink icon in switcher menu
  button or not. Fixes: NB#68371.

  * libhildondesktop/hildon-desktop-panel-expandable.c:
  (hildon_desktop_panel_expandable_constructor):
  - Insert the GtkTable into a GtkFrame
  * src/hd-panel-window-dialog.c:
  (hd_panel_window_dialog_constructor):
  - Set the theme to GtkTable's parent. Fixes partially: NB#65211

  * libhildondesktop/hildon-desktop-panel.c:
  (hildon_desktop_panel_refresh_items_status):
  - When refreshing items check if the container is a
  composited one (or so called hildon-desktop-container).
  Fixes: NB#63897

  * src/hd-switcher-menu.c (hd_switcher_menu_show_menu_cb): do not emit
  "toggled" signal twice to avoid popping up the switcher menu window 
  when it's already shown. Fixes: NB#65709.

  * libhildondesktop/hildon-home-area.c:
  - include the widgets to be batch-added in _forall

  * src/hd-switcher-menu.c (hd_switcher_menu_changed_info_cb): check
  menu item before testing the blinking in order to avoid critical
  warnings.

  * libhildondesktop/hildon-desktop-multiscreen.c:
  - properly pass the object as data to the size-changed handlers.
  Fixes: NB#66644

  * libhildondesktop/hildon-desktop-popup-menu.c
  (hildon_desktop_popup_menu_release_event,
  hildon_desktop_popup_menu_press_event): handle selection on button
  press and menu item activation on release in order to explicitly 
  show the selection before activation. Fixes: NB#61740.

  * libhildondesktop/hildon-desktop-panel-window-composite.c.
  libhildondesktop/hildon-desktop-toggle-button.c:
  - chain style_set to parent class

  * libhildonwm/hd-wm.c: Fixed the leak of an X property

  * src/hd-switcher-menu-item.c (hd_switcher_menu_item_icon_animation):
  add some safety checks before setting back from animation to pixbuf
  when blinking is disabled.
  * src/hd-switcher-menu.c (hd_switcher_menu_changed_info_cb): disable
  blinking when the when the window entry info is not urgent anymore.
  Fixes: NB#58375.

  * libhildondesktop/hildon-desktop-picture.c,
  libhildondesktop/hildon-desktop-toggle-button.c,
  libhildondesktop/hildon-home-area.c,
  libhildondesktop/hildon-desktop-panel-window-composite.c,
  src/hd-home-window.c:
  - added some safeguard for X errors.

  * src/hd-switcher-menu.c (hd_switcher_menu_clear_item_activated), 
  src/hd-desktop.c (hd_desktop_system_notifications_filter): fix 
  checking of notification category prefixes. Fixes: #NB65180.



=== debian/control ===
Source: hildon-desktop
Section: x11
Priority: optional
Maintainer: Johan Bilien <johan.bilien@nokia.com>
Build-Depends: debhelper (>= 4.0.0), libhildon1-dev | hildon-libs-dev, pkg-config, libosso-dev (>= 0.9.19), libosso-gnomevfs2-dev, osso-af-settings, libhildonfm2-dev | hildon-fm-dev, libhildonhelp-dev | libosso-help-dev, libxtst-dev, libxml2-dev, osso-esd-dev, libxdamage-dev, libxcomposite-dev, libsqlite3-dev, mce-dev, gtk-doc-tools, maemo-launcher-dev (>= 0.23-1)
Standards-Version: 3.6.0

Package: hildon-desktop
Section: x11
Architecture: any
Depends:  ${shlibs:Depends}, ${misc:Depends}, ${launcher:Depends}, maemo-af-desktop-l10n-mr | maemo-af-desktop-l10n-mr0
Conflicts: maemo-af-desktop (<< 3.0.0), maemo-af-desktop-config
Description: Desktop environment for embedded devices
  Hildon Desktop is a desktop environment for embedded devices. It
  is based on the GNOME platform

Package: hildon-desktop-dev
Section: x11
Architecture: all
Depends:  ${shlibs:Depends}, ${misc:Depends}, libhildondesktop-dev, libhildonwm-dev
Description: Development files for the Hildon Desktop
  Hildon Desktop is a desktop environment for embedded devices. It
  is based on the GNOME platform. This package contains the
  development headers required to create new plugin loaders.

Package: hildon-desktop-dbg
Section: devel
Architecture: any
Depends: hildon-desktop (=${Source-Version})
Description: Debug symbols for hildon-desktop
  Debug symbols for hildon-desktop

Package: libhildondesktop0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libhildondesktop shared library
  Set of widgets to build desktop elements in the Hildon Desktop
  environment

Package: libhildondesktop-dev
Section: devel
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libhildondesktop0 (=${Source-Version}), libhildon1-dev | hildon-libs-dev, libxml2-dev
Description: libhildondesktop development files
  Development headers and static libraries for the libhildondesktop

Package: libhildondesktop0-dbg
Section: devel
Architecture: all
Depends: libhildondesktop0 (=${Source-Version})
Description: libhildondesktop debug symbols
  Debugging symbols for libhildondesktop0

Package: libhildonwm0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: libhildonwm shared library
  Set of tools for window managing from desktop environments

Package: libhildonwm-dev
Section: devel
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}, libhildondesktop0 (=${Source-Version}), libxtst-dev, libx11-dev, libhildon1-dev | hildon-libs-dev, libgconf2-dev
Description: libhildonwm development files
  Development headers and static libraries for the libhildonwm

Package: libhildonwm0-dbg
Section: devel
Architecture: all
Depends: libhildonwm0 (=${Source-Version})
Description: libhildonwm debug symbols
  Debugging symbols for libhildonwm0

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifeq (,$(findstring nolauncher,$(DEB_BUILD_OPTIONS)))
   LAUNCHER = yes
   LAUNCHER_DEPENDS = -Vlauncher:Depends="maemo-launcher"
   LAUNCHER_CFLAGS = $(shell pkg-config --cflags maemo-launcher-app)
   LAUNCHER_LDFLAGS = $(shell pkg-config --libs maemo-launcher-app)
endif

# Use soft-float and thumb mode if it enabled.
ifneq (,$(findstring thumb,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -mthumb -fPIC
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -ggdb -DDEBUG
endif

# shared library versions, option 1
version=0.0.0
major=0
# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
#version=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
#major=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

config.status: configure
	dh_testdir
# Add here commands to configure the package.
	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --sysconfdir=/etc --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --disable-dependency-tracking


build: build-stamp
build-stamp:  config.status
	dh_testdir

# Add here commands to compile the package.
	$(MAKE) LAUNCHER_CFLAGS="$(LAUNCHER_CFLAGS)" LAUNCHER_LDFLAGS="$(LAUNCHER_LDFLAGS)"
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

# Add here commands to clean up after the build process.
	-$(MAKE) distclean
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean 

install: build
	dh_testdir
	dh_testroot
#	dh_clean -k 
	dh_installdirs

# Add here commands to install the package into debian/build
	$(MAKE) install DESTDIR=$(CURDIR)/debian/build
	install -m644 $(CURDIR)/debian/config/*.conf $(CURDIR)/debian/build/etc/hildon-desktop
	install -m644 $(CURDIR)/debian/config/*.menu $(CURDIR)/debian/build/etc/xdg/menus

ifeq "$(strip $(LAUNCHER))" "yes"
	mv debian/build/usr/bin/hildon-desktop debian/build/usr/bin/hildon-desktop.launch
	ln -s maemo-invoker debian/build/usr/bin/hildon-desktop
endif

configure: configure-stamp

configure-stamp:
	dh_testdir
	./autogen.sh
	touch configure-stamp

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
#	dh_installexamples
	dh_installdocs
	dh_install --sourcedir=debian/build -v
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip --dbg-package="hildon-desktop" --dbg-package="libhildondesktop0" --dbg-package="libhildonwm0"
	dh_compress
	dh_fixperms
	dh_installinit -- start 51 2 3 4 . stop 20 0 1 5 6 .
#	dh_perl
#	dh_python
	dh_makeshlibs -V
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol -- $(LAUNCHER_DEPENDS)
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## hildon-desktop 0.0.37-1

=== debian/changelog ===
hildon-desktop (1:0.0.37-1) sardine; urgency=low

  * libhildondesktop/hildon-home-titlebar.c: move the label
  3 px higher. Fixes: NB#69642

  * src/hn-app-button.c:
  - set the previous button even if it happens to be the same as
  the new one
  - when the group menu is closed, if no previous active button,
  unset current button.
  Fixes: NB#70354

  * src/hd-applications-menu.c (hd_applications_menu_activate_category):
  use new method for replacing items in popup menu.
  * src/hd-switcher-menu.c
  (hd_switcher_menu_create_clear_notifications_button,
  hd_switcher_menu_add_clear_notifications_button,
  hd_switcher_menu_get_icon_from_theme,
  hd_switcher_menu_add_notification_groups,
  hd_switcher_menu_create_notifications_menu): refactored the whole
  notification pane creation to use the new method for replacing
  items in popup menu.
  * libhildondesktop/hildon-desktop-popup-menu.c
  (hildon_desktop_popup_menu_add_items,
  hildon_desktop_popup_menu_remove_all,
  hildon_desktop_popup_menu_parent_size,
  hildon_desktop_popup_menu_replace_items): new method for replacing
  items in popup menu. Make sure the parent is resized before moving
  it to another position. Fixes: NB#65712.

  * src/hd-app-menu-settings-dialog.c: check for duplicate names
  on the stripped name, not the original. Fixes: NB#70314

  * libhildonwm/hd-wm-window.c: set the parent pointer to the
  parent app when creating a new window. Fixes: NB#70125

  * src/hd-switcher-menu.c: when removing an item, unselect
  it if selected
  * libhildondesktop/hildon-desktop-popup-menu.c: ensure that we
  are always calling popup_menu_remove rather than container_remove.
  Fixes: NB#70281

  * src/hd-select-plugins-dialog.c, src/hd-home-background.c:
  - Fixed memory leaks. Fixes: NB#70273

  * src/hd-switcher-menu.c: (hd_switcher_create_external_window):
  - Fixed size for deattached button. Fixes: NB#70344

  * src/hd-panel-window-dialog.c:
  (hd_panel_window_dialog_notify_condition):
  - Send a real DBus signal.

  * src/hd-app-menu-tree.c: set an abitrary default value
  to the paned position.

  * libhildondesktop/hildon-desktop-home-item.c: when passing
  along a button-release, use the button release event
  rather than the previous button-press

  * src/hd-applications-menu.c (hd_applications_menu_activate_category):
  make sure focus is correctly painted when the same category is
  activated twice.

  * src/hd-home-window.c: make sure to save the background always
  when pressing Ok. Fixes: NB#69800

  * src/hd-switcher-menu.c (hd_switcher_menu_show_menu_cb): do not show
  pressed state in toggle button if there are no applications running
  and Home key is pressed. Fixes: NB#69681.

  * src/main.c: add a signal handler for SIGTERM, in which
  desktop sends a SIGTERM to all watched applications.
  Fixes: NB#69408

  * libhildonwm/hd-keys.c: (hd_keys_shortcut_new):
  - Fixed typo with - and + keys

  * src/hd-applications-menu.c (hd_applications_menu_create_menu,
  hd_applications_menu_activate_category): make sure the menu can't be
  opened while loading its content in order to avoid crashers.
  Fixes: NB#68975.

  * src/hd-applications-menu.c (hd_applications_menu_activate_category):
  use new optimized functions to add and remove several items at once.
  * libhildondesktop/hildon-desktop-popup-menu.[ch]
  (hildon_desktop_popup_menu_add_item,
  hildon_desktop_popup_menu_add_items,
  hildon_desktop_popup_menu_real_add_item,
  hildon_desktop_popup_menu_remove_item,
  hildon_desktop_popup_menu_remove_all,
  hildon_desktop_popup_menu_real_remove_item): new functions to add
  several items at once in the menu and to remove all items.

  * policies/tasknavigator-policy.c:
  (hd_ui_policy_module_filter_plugin_list):
  - Filter any previous position of the switcher plugins.
  Fixes: NB#69004

  * libhildondesktop/libhildonmenu.[ch]: added support for
  the NoDisplay field

  * src/hd-switcher-menu.c (hd_switcher_menu_refresh_application_items):
  make sure the blinking is stopped when display is off inside
  the switcher
  menu applications pane. Removed some useless debugging messages.

  * libhildondesktop/hildon-desktop-panel-expandable.c:
  (hildon_desktop_x_event_filter),
  (hildon_desktop_panel_embed_applet):
  - Increment number of systray applets. Fixes: NB#60764

  * src/hn-app-button.c (hn_app_button_create_menu): set toplevel window
  name for application instances menu to make it consistent with other
  plugins in tasknavigator.

  * src/hn-app-pixbuf-anim-blinker.c: (get_delay_time):
  - Set a fixed amount of time in order to save some CPU %.
  Fixes: NB#60062

 -- Johan Bilien <johan.bilien@nokia.com>  Fri, 21 Sep 2007 13:06:10 +0300

hildon-desktop (1:0.0.36-3) feisty; urgency=low

  * make startup sript scratchbox-friendly. Fixes: MB#1747

 -- Johan Bilien <johan.bilien@nokia.com>  Wed, 19 Sep 2007 13:00:37 +0300

hildon-desktop (1:0.0.36-2) sardine; urgency=low

  * debian/config/applications.menu: some adjustment

 -- Johan Bilien <johan.bilien@nokia.com>  Mon, 17 Sep 2007 17:05:56 +0300

hildon-desktop (1:0.0.36-1) sardine; urgency=low

  * src/hd-switcher-menu.c (hd_switcher_menu_displat_state_cb),
  src/hn-app-switcher.c (hn_app_switcher_osso_display_state_cb): keep
  track of display state changes instead of general system inactivity.

  * src/hd-app-menu-dialog.c: Fixed the leak of a string

  * libhildondesktop/hildon-desktop-picture.c: sync with X
  after creating a picture

  * src/hd-switcher-menu.c (hd_switcher_menu_popup_window_keypress_cb,
  hd_switcher_menu_popup_window_pane_keypress_cb): fixed keyboard
  navigation between application and notification panes. 

  * libhildondesktop/hildon-desktop-home-item.c: Added safegard
  against button-release without previous button-press.
  Fixes: NB#69560

  * src/hn-app-button.c (hn_app_button_release_event): restore previous
  state in case the release event occurs outside button boundaries.
  Fixes: NB#69245



## hildon-desktop 0.0.38-1

=== debian/changelog ===
hildon-desktop (1:0.0.38-1) sardine; urgency=low

  * src/hd-home-window.c: kill the startup wizard in an idle loop,
  to make sure we are all setup.
  Fixes: NB#68956

  * src/hd-applications-menu.c (hd_applications_menu_dir_changed):
  reduce the timeout to update the menu in order to avoid strange
  behavior from the user point of view. Fixes: NB#68975.

  Added "safe mode" support which, in practice, disables all home plugins 
  and loads default ones for task navigator and statusbar. Based on
  patch from Karoliina Salminen <karoliina.t.salminen@nokia.com>.

  * debian/rules: added --enable-safe-mode option to configure step.
  * debian/config/desktop.conf: added UI policy key for statusbar.
  * src/hd-desktop.c (hd_desktop_init, hd_desktop_load_containers):
  create a stamp file on startup which should be removed on a normal 
  desktop shutdown. On startup, if the file is still there it means
  desktop didn't shutdown normally on previous session and the safe mode
  should be activated. If running in a development environment, then safe 
  mode is disabled.
  * src/hd-desktop.h: added constants for the stamp file used by safe
  more code.
  * src/main.c (signal_handler): remove stamp file on SIGTERM to mark
  a plain shutdown. 
  * policies/statusbar-policy.c: new statusbar UI policy which loads all
  default plugins in case the desktop is in safe mode.

  * libhildondesktop/hildon-home-area.c: removed debug message
  * libhildondesktop/hildon-desktop-home-item.c: removed warning
  when no close icon is provided

  * src/hd-panel-window-dialog.c: fixed potential leak of an int

  * libhildondesktop/libhildonmenu.c (read_menu_conf): do not
  duplicate strings before adding to the TreeStore

  * src/hd-switcher-menu-item.c: fixed the leak of the application
  and window names

  * libhildondesktop/hildon-desktop-panel-expandable.c
  (hildon_desktop_panel_expandable_cadd): fixed the leak of a GList

  * src/hd-panel-window.c (hd_panel_window_cadd): fixed leak of
  a GList

  * src/hd-applications-menu.c (hd_applications_menu_create_menu):
  increased the applications pane in order to avoid many truncations on
  several languages. Fixes: NB#65999.

  * src/hd-applications-menu.c (hd_applications_menu_create_menu): pack
  both panes inside event boxes in order to avoid flicking on scrolling
  buttons area when opening the popup window.

  Refactored memory management of the switcher icons
  * src/hd-switcher-menu-item.c
  - (hd-switcher-menu-item_set_property): keep an internal reference
  to the notification icon
  - (hd_switcher_menu_item_icon_animation): when moving from
  animation to static, do not unref the original pixbuf
  * src/hn-app-pixbuf-anim-blinker.c
  (hn_app_pixbuf_anim_blinker_finalize): unref the blended image
  * src/hd-switcher-menu.c: unref a notification icon after
  a notification menu item is created
  Fixes: NB#70872, NB#70670

  * src/hd-applications-menu.c (hd_applications_menu_activate_category):
  reverted some remaining changes from the previous leak fix in order to make the
  keyboard navigation work again.

  * src/hd-applications-menu.c (hd_applications_menu_activate_category):
  reverted some changes from the previous leak fix in order to make the
  focus move between panes work again.

  * src/hd-desktop.c (hd_desktop_plugin_list_from_conf): duplicate
  the group name if we add it to the plugin list.

  * src/hd-applications-menu.c (hd_applications_menu_activate_category):
  fixed the leak of a GList

  * src/hd-desktop.c (hd_desktop_plugin_list_from_conf): free
  the KeyFile in case of error.

  * src/hd-desktop.c (hd_desktop_plugin_list_from_conf): use
  g_strfreev() to free the list of groups returned by gconf. Fixes
  a leak of strings

  * libhildondesktop/hildon-desktop-notification-manager.c: unref
  the notification icon after storing it in the ListStore, to avoid
  leaking it

  * libhildondesktop/hildon-desktop-panel.c (hildon_desktop_panel_cadd):
  added protection against NULL widget. Fixes: NB#70668

  * libhildondesktop/hildon-desktop-popup-menu.c: systematically
  unselect the item when removed from the box. This fixes invalid
  reads

  * src/hd-switcher-menu.c: fixed numerous leaks of GList.

  * libhildondesktop/hildon-desktop-popup-menu.c: fixed a warning
  when deselecting a NULL item

  * src/hd-switcher-menu.c (hd_switcher_menu_changed_info_cb): make sure
  the menu item icon blinks when urgency hint is set for a certain
  window. Fixes: NB#58375.

  * src/hd-panel-window-dialog.c:
  (hd_panel_window_dialog_notify_condition):
  - Get the condition anyways and send it off. Fixes: NB#70308

  * src/hd-applications-menu.c (hd_applications_menu_get_items): center
  the "no applications" label on empty categories menu item.

  * libhildonwm/hd-keys.c: (hd_keys_action_close):
  * libhildonwm/hd-keys.h:
  - New gconf key for shorcuts.

  * src/hd-panel-window-dialog.c:
  (hd_panel_window_dialog_constructor):
  - If using old titlebar MB dirty-hack, never hide statusbar.
  Fixes: NB#70648, NB#70348, NB#69706

  * libhildondesktop/hildon-desktop-notification-manager.c
  (hildon_desktop_notification_manager_notify): fix memory leak.
  Fixes: NB#70273.

  * libhildondesktop/hildon-desktop-popup-window.c
  (hildon_desktop_popup_window_realize): don't set back pixmap to NULL
  to make avoid the "partial paint" effect on realize. Fixes: NB#69156.

  * src/hd-plugin-manager.c: free the list of plugins returned by
  the plugin loaders

  * libhildonwm/hd-keys.c: fixed the leak of the strings retrieved
  from gconf

  * libhildonwm/hd-wm.c: do not send the application-starting signal
  if the application has a window already or has requested not
  to show notifications.

  * libhildondesktop/hildon-thumb-menu-item.c: do not disable
  ellipses. Fixes: NB#70867

  * src/hd-app-menu-tree.c (hd_app_menu_tree_navigation_row_deleted):
  - set the cursor in an idle loop rather than directly, to prevent


## hildon-desktop 0.0.39-1

=== debian/changelog ===
hildon-desktop (1:0.0.39-1) sardine; urgency=low

  * src/hd-home-background.c (hd_home_background_requires_caching):
  - check for both MMC and cache the background for both origin,
  as both will be made unavailable if connected to a host.

  * libhildondesktop/hildon-desktop-toggle-button.c
  (hildon_desktop_toggle_button_expose): paint the button on
  its allocation only. Fixes: NB#71538

  * src/hd-desktop.c: removed debug message

  * libhildondesktop/hildon-desktop-panel-expandable.c
  (hildon_desktop_panel_expandable_hide_extension): do not hide the
  extension if already hidden. In particular don't release grabs
  which we didn't take. Fixes: NB#71191

 -- Johan Bilien <johan.bilien@nokia.com>  Mon, 01 Oct 2007 19:34:02 +0300

=== debian/rules ===
--- 
+++ 
@@ -53,7 +53,7 @@
 config.status: configure
 	dh_testdir
 # Add here commands to configure the package.
-	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --sysconfdir=/etc --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --disable-dependency-tracking
+	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --sysconfdir=/etc --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --disable-dependency-tracking --enable-safe-mode
 
 
 build: build-stamp

## hildon-desktop 0.0.40-1

=== debian/changelog ===
hildon-desktop (1:0.0.40-1) sardine; urgency=low

  * libhildonwm/hd-wm-application.c: do not #define out gettext!
  Fixes: NB#69635

  * src/hd-applications-menu.c (hd_applications_menu_finalize,
  hd_applications_menu_activate_category,
  hd_applications_menu_free_menu_list, hd_applications_menu_create_menu,
  hd_applications_menu_get_items, hd_applications_menu_populate):
  complete refactoring of the way applications pane is update. Instead
  of removing and adding items from the popup menu widget, we just add
  all application menu items to the popup menu and keep hinding and
  showing certain menu items each time a category is activated. This
  brings a mass performance improvement as GTK+ doesn't perform very
  well with massively adding/removing widgets from containers.
  * src/hd-switcher-menu.c (hd_switcher_menu_init,
  hd_switcher_menu_eventbox_keypress_cb): add an eventbox around the
  popup menus in order to avoid flickers on scroll buttons area.
  Explicitly show menu items on their creation as the popup menu doesn't
  call gtk_widget_show on them anymore.
  * libhildondesktop/hildon-desktop-popup-menu.[ch]
  (hildon_desktop_popup_menu_get_children,
  hildon_desktop_popup_menu_parent_size,
  hildon_desktop_popup_menu_item_is_valid,
  hildon_desktop_popup_menu_motion_notify): take in to account the
  visibility of the menu items on all basic operations on popup menu
  like motion notify, keyboard navigation, getting children, etc.

 -- Johan Bilien <johan.bilien@nokia.com>  Tue, 02 Oct 2007 14:35:08 +0300

## hildon-desktop 0.0.41-1

=== debian/changelog ===
hildon-desktop (1:0.0.41-1) sardine; urgency=low

  * libhildonwm/hd-wm.[ch]: (hd_wm_constructor), (hd_wm_init),
  (hd_wm_monitor_cb), (hd_wm_monitor_register):
  - Refresh list of applications when un/installing. Fixes: NB#72107
  * src/hn-app-switcher.c:
  (hn_app_switcher_close_application_dialog):
  - Use the proper hd_wm_entry_info
  
  * libhildondesktop/hildon-thumb-menu-item.c
  (hildon_thumb_menu_item_style_set, hildon_thumb_menu_class_init):
  refresh style of menu item labels in case of a theme change.
  Fixes: NB#72056.
  
  * src/hn-app-button.c, src/hd-switcher-menu-item.c: defined a default
  height for menu items and reduced x padding in order to bring more
  consistency to switcher area menu in relation to other tasknavigator
  menus. Fixes: NB#71584.
  
  * libhildonwm/hd-wm-window.c: the icons we should accept
  are 64x54, not 40x40. Fixes: NB#71511
  
  * libhildondesktop/hildon-desktop-home-item.c
  (hildon_desktop_home_item_propagate_button_event): when forwarding
  button-release events, lookup for the child window using the
  previous button-press event coordinates. Fixes: NB#71808
  
  * src/hd-desktop.c: fixed the leak of a GList
  
  * src/hd-switcher-menu.c (hd_switcher_menu_notification_deleted_cb):
  turn off led pattern blinking when a notification with led blinking
  closes. Fixes: NB#71832.

 -- Lucas Rocha <lucas.rocha@nokia.com>  Fri,  5 Oct 2007 17:06:10 +0300

## hildon-desktop 0.0.42-1

=== debian/changelog ===
hildon-desktop (1:0.0.42-1) sardine; urgency=low

  * libhildondesktop/hildon-desktop-panel-expandable.c:
  - (hildon_desktop_panel_expandable_constructor): keep the id
  of the fullscreen signal handler
  - (hildon_desktop_panel_expandable_finalize): disconnect the
  fullscreen signal handler.
  Fixes: NB#72260

 -- Johan Bilien <johan.bilien@nokia.com>  Mon, 08 Oct 2007 14:46:11 +0300

## hildon-desktop 0.0.44-1

=== debian/changelog ===
hildon-desktop (1:0.0.44-1) sardine; urgency=low

  * libhildonwm/hd-wm-window.c: call gdk_flush before checking for
  an X error. Fixes: NB#72458

  * src/hd-switcher-menu.c
  (hd_switcher_menu_create_clear_notifications_button):
  call gtk_widget_show on "clear events" menu item.

 -- Johan Bilien <johan.bilien@nokia.com>  Wed, 10 Oct 2007 12:47:53 +0300

hildon-desktop (1:0.0.43-1) sardine; urgency=low

  * src/hd-switcher-menu.c (hd_switcher_menu_create_separator):
  call gtk_widget_show on each created menu separator.

  * libhildonwm/hd-wm-application.c: (hd_wm_application_new):
  - If not icon provided at all fallback to default.

  * libhildonwm/hd-wm.c: (hd_wm_prepare_close_application_dialog):
  - Use the new HD_WM_ENTRY_INFO semantics. The list of applications
  contains applications not windows. Fixes: NB#72499

 -- Johan Bilien <johan.bilien@nokia.com>  Tue, 09 Oct 2007 15:58:58 +0300

## hildon-desktop 0.0.46-1

=== debian/changelog ===
hildon-desktop (1:0.0.46-1) sardine; urgency=low

  * libhildondesktop/home-item.[ch]: use HOME_ as prefix
  for the GObject macros, to make the python binding generator
  happy.

  * libhildondesktop/hildon-desktop-home-item.c: enable
  extension events on the event window, so the pressure
  information is propagated to child widgets. Patch courtesy
  of Tomas Junnonen. Fixes: NB#73005

 -- Johan Bilien <johan.bilien@nokia.com>  Tue, 16 Oct 2007 15:27:13 +0300

hildon-desktop (1:0.0.45-2) sardine; urgency=low

  * debian/control: libhildon*-dbg should be built for any architecture.
  Fixes: NB#72826

 -- Johan Bilien <johan.bilien@nokia.com>  Mon, 15 Oct 2007 18:55:46 +0300

hildon-desktop (1:0.0.45-1) sardine; urgency=low

  * libhildonwm/hd-wm-window.c (hd_wm_window_finalize):
  do not return when the window is hibernating. We do destroy
  windows which are hibernating when an application has not
  set up its WINDOW_ROLE, in which case all its windows have the
  same hibernation key.
  * src/hd-switcher-menu.c: do not check urgency of hibernating windows
  * src/hn-app-switcher.c: do not check urgency and icon geometry
  of hibernated window.
  Fixes: NB#72572

  * libhildonwm/hd-wm.c (hd_wm_prepare_close_application_dialog):
  plugged the leak of an X property

  * debian/config/notification-groups.conf: update notification group
  configuration file with correct e-mail notification group callback.

  * src/hd-applications-menu.c (hd_applications_menu_activate_app):
  plugged the leak of a string vector

  * libhildonwm/hd-wm-window.c (hd_wm_win_info_get_window_name): Fixed
  the leak of a string

  * libhildonwm/hd-keys.c: (hd_keys_handle_keypress):
  - Trap possible X errors. Fixes potential crash.

 -- Johan Bilien <johan.bilien@nokia.com>  Thu, 11 Oct 2007 16:00:17 +0300

=== debian/control ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 Package: libhildondesktop0-dbg
 Section: devel
-Architecture: all
+Architecture: any
 Depends: libhildondesktop0 (=${Source-Version})
 Description: libhildondesktop debug symbols
   Debugging symbols for libhildondesktop0
@@ -68,7 +68,7 @@
 
 Package: libhildonwm0-dbg
 Section: devel
-Architecture: all
+Architecture: any
 Depends: libhildonwm0 (=${Source-Version})
 Description: libhildonwm debug symbols
   Debugging symbols for libhildonwm0

## hildon-desktop 2.0.1-2

=== debian/changelog ===
hildon-desktop (1:2.0.1-2) sardine; urgency=low

  * debian/control:
    . added libhildondesktop0-doc
    . added Build-Depends-Indep to gtk-doc-tools
  * debian/rules:
    . enable gtk-doc
    . add a symlink from /usr/share/gtk-doc/html
  * debian/libhildondesktop0-doc.install: added

 -- Johan Bilien <johan.bilien@nokia.com>  Fri, 19 Oct 2007 15:37:33 +0300

hildon-desktop (1:2.0.1-1) sardine; urgency=low

  * src/hd-switcher-menu.c
  (hd_switcher_menu_refresh_notification_items): check if items
  are HDSwitcherMenuItem before accessing them.

  * libhildondesktop/libhildondesktop.h: document
  HD_DEFINE_PLUGIN_EXTENDED and HD_DEFINE_PLUGIN.

  * libhildondesktop/tasknavigator-item.[ch]: document
  TaskNavigatorItem (mark public fields as private).

  * doc/hildon-desktop-docs.sgml: add package version number.
  * libhildondesktop/hildon-desktop-panel-item.[ch]: add
  HildonDesktopPanelItem documentation.

  * doc/hildon-desktop-docs.sgml: make the index.html more elegant.
  * doc/hildon-desktop.types: introspect PopupWindow and PopupMenu
  too.

  * libhildondesktop/statusbar-item.[ch]: fix StatusbarItem
  documentation (mainly state things as private).

  * libhildondesktop/hildon-log.[ch]:
  * libhildondesktop/statusbar-item-binding.[ch]:
  * libhildondesktop/statusbar-item-socket.[ch]:
  * libhildondesktop/statusbar-item-wrapper.[ch]:
  * libhildondesktop/tasknavigator-item-socket.[ch]:
  remove _PRIVATE macros from public headers.

  * doc/Makefile.am:
  fix GtkDoc documentation build.

 -- Johan Bilien <johan.bilien@nokia.com>  Thu, 18 Oct 2007 14:51:16 +0300

hildon-desktop (1:2.0.0-1) sardine; urgency=low

  * src/hd-applications-menu.c (hd_applications_menu_activate_category):
  fix an invalid read by adding a weak pointer to the internal static
  variable that points to the last selected item. Fixes: NB#73505.
  * libhildondesktop/hildon-desktop-panel-expandable.c
  (hildon_desktop_desktop_panel_expandable_cremove): fix a leak by
  freeing an temporary list.
  * libhildonwm/hd-wm.c (hd_wm_activate_service): fix memory leak.

  * libhildondesktop/hildon-desktop-home-item.c: reverted activating
  the extension events, as it breaks resizing and context sensitive
  menu

 -- Johan Bilien <johan.bilien@nokia.com>  Wed, 17 Oct 2007 16:48:17 +0300

=== debian/rules ===
--- 
+++ 
@@ -41,6 +41,12 @@
 	CFLAGS += -ggdb -DDEBUG
 endif
 
+ifeq (,$(findstring nodocs,$(DEB_BUILD_OPTIONS)))
+ENABLE_GTK_DOC = --enable-gtk-doc
+else
+ENABLE_GTK_DOC = --disable-gtk-doc
+endif
+
 # shared library versions, option 1
 version=0.0.0
 major=0
@@ -53,7 +59,7 @@
 config.status: configure
 	dh_testdir
 # Add here commands to configure the package.
-	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --sysconfdir=/etc --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --disable-dependency-tracking --enable-safe-mode
+	CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --sysconfdir=/etc --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --disable-dependency-tracking --enable-safe-mode --with-html-dir=\$${prefix}/share/doc/libhildondesktop0-doc $(ENABLE_GTK_DOC)
 
 
 build: build-stamp
@@ -106,7 +112,10 @@
 
 # Build architecture-independent files here.
 binary-indep: build install
-# We have nothing to do by default.
+	dh_link -plibhildondesktop0-doc			\
+		usr/share/doc/libhildondesktop0-doc/hildon-desktop	\
+		usr/share/gtk-doc/html/hildon-desktop;		\
+
 
 # Build architecture-dependent files here.
 binary-arch: build install

## hildon-desktop 2.0.2-1

=== debian/changelog ===
hildon-desktop (1:2.0.2-1) sardine; urgency=low

  * src/hd-home-background.c,
  libhildondesktop/hildon-desktop-panel-window-composite.c:
  fixed compilation warnings. Patch courtesy of Xan López.

  * doc/libhildondesktop: moved libhildondesktop documentation
  to its own subdirectory, with its own gtk-doc module.

 -- Johan Bilien <johan.bilien@nokia.com>  Wed, 24 Oct 2007 13:26:01 +0300

hildon-desktop (1:2.0.1-3) sardine; urgency=low

  * debian/config/home{-layout}.conf: replaced tutorial with clock 
    applet. Fixes: NB#74145

 -- Johan Bilien <johan.bilien@nokia.com>  Wed, 24 Oct 2007 13:24:42 +0300

=== debian/rules ===
--- 
+++ 
@@ -113,8 +113,8 @@
 # Build architecture-independent files here.
 binary-indep: build install
 	dh_link -plibhildondesktop0-doc			\
-		usr/share/doc/libhildondesktop0-doc/hildon-desktop	\
-		usr/share/gtk-doc/html/hildon-desktop;		\
+		usr/share/doc/libhildondesktop0-doc/libhildondesktop	\
+		usr/share/gtk-doc/html/libhildondesktop;		\
 
 
 # Build architecture-dependent files here.

## hildon-desktop 2.0.6-1

=== debian/changelog ===
hildon-desktop (1:2.0.6-1) sardine; urgency=low

  * libhildonwm/hd-keys.c: check if a fn + keycode gives keysym,
  but also if keycode only does not give keysym.
  Fixes NB#74429

  * libhildondesktop/hildon-home-titlebar.c: use button1 in
  gtk_menu_popup. Fixes: NB#76713

 -- Johan Bilien <johan.bilien@nokia.com>  Thu, 22 Nov 2007 14:42:43 +0200

hildon-desktop (1:2.0.5-1) sardine; urgency=low

  * libhildonwm/hd-keys.c:
  - when grabbing a shortcut, check if that keysym requires the Fn
  modifiers, and if so add it to the modifier mask. For instance
  the + key in French is labelled as + but requires Fn+V.
  - when a key shortcut is received, check if this keycode and
  mask results in a levelled keysym.
  Fixes: NB#74322

  * src/hd-applications-menu.c (hd_applications_menu_button_toggled): do
  not unselect menu item when untoggling the button to avoid
  inconsistent behavior. Fixes: NB#75922.

 -- Johan Bilien <johan.bilien@nokia.com>  Wed, 21 Nov 2007 16:32:24 +0200

hildon-desktop (1:2.0.4-2) sardine; urgency=low

  * debian/config/home{-layout}.conf: the tutorial applet is back, for
  everyone's pleasure.

 -- Johan Bilien <johan.bilien@nokia.com>  Mon, 19 Nov 2007 13:10:51 +0200

hildon-desktop (1:2.0.4-1) sardine; urgency=low

  * libhildonwm/hd-wm.c (hd_wm_prepare_close_application_dialog):
  - add a weak reference to the window so it can be set to NULL
  if it disappears.
  - clean up the list where it is constructed.
  * src/hn-app-switcher.c (hn_app_switcher_close_application_dialog):
  - do not clean up the list as it is done by the caller.
  Fixes: NB#74429

  * src/hd-home-l10n.h, src/hd-applications-menu-settings-l10n.h,
  libhildondesktop/statusbar-item-socket.h,
  libhildondesktop/tasknavigator-item-socket.h: added missing
  G_END_DECLS. Patch courtesy of Mikhail Sobolev

  * libhildondesktop/hildon-desktop-popup-menu.c
  (hildon_desktop_popup_menu_press_event): do not take non-visible menu
  items into account when checking which item was selected on button
  press. Fixes: NB#75589.

  * src/hd-applications-menu.c (hd_applications_menu_finalize,
  hd_applications_menu_init, hd_applications_menu_create_menu): use an
  idle call instead of timeout to first load menu structure on startup. 

  * src/hd-home-window.c: if an image has a cache, that's the file
  whose existence we should check. Fixes: NB#72925

 -- Johan Bilien <johan.bilien@nokia.com>  Mon, 12 Nov 2007 09:38:57 +0200

hildon-desktop (1:2.0.3-1) sardine; urgency=low

  * src/hd-home-window.c (hd_home_window_constructor): if the background
  file has disappeared, revert to default. Fixes: NB#72925

  * src/hd-switcher-menu.c (hd_switcher_menu_fullscreen_cb): only reset
  switcher button icon if the application is only shown in switcher menu
  and there's no blinking notification icon. Fixes: NB#72861, NB#72860.

  * src/hd-switcher-menu.c (hd_switcher_menu_fullscreen_cb): revert last
  commit as it brings one regression when blinking icon on switcher area.

  * src/hd-switcher-menu.c (hd_switcher_menu_fullscreen_cb): do not
  reset switcher button icon when fullscreen signal is false in order to
  avoid stopping the blinking when launching an application or coming
  back from fullscreen mode. Fixes: NB#72861, NB#72860.

  * src/hd-switcher-menu.c (hd_switcher_menu_displat_state_cb,
  hd_switcher_menu_finalize): copy animation pixbuf when restoring
  blinking icon on switcher button to avoid it to be destroyed just
  before using it. Fixes: NB#72544.

  * src/hd-plugin-loader-factory.c
  (hd_plugin_loader_factory_load_modules): g_strdup() the plugin loader
  key to fix a crasher. Do not use G_MODULE_BIND_LOCAL flag when loading
  plugin loader module in order to correctly load all its dependencies in
  the global symbol table.

  * src/hd-applications-menu.c (hd_applications_menu_unmap,
  hd_applications_menu_init): make the initial setup (select first
  category) on window unmap instead of window popdown in order to avoid
  errouneous applications activation when doing double clicks.
  Fixes: NB#73137.

  * libhildondesktop/hildon-desktop-panel-window-composite.c
  - (hildon_desktop_panel_window_composite_update_background):
  store a GdkPixmap instead of a Render Picture for the background,
  and apply it as window background.
  - (hildon_desktop_panel_window_composite_expose): removed.
  - (hildon_desktop_panel_window_composite_finalize): added, unref
  the background pixmap.
  Fixes: NB#72438

  * libhildondesktop/hildon-desktop-home-item.c: enable GTK
  extension events on both the event window and the
  close / resize handles. Fixes: NB#73005

  * src/hd-switcher-menu.c: fixed a compiler warning. Fix courtersy
  of Xan López.

 -- Johan Bilien <johan.bilien@nokia.com>  Tue, 30 Oct 2007 09:53:06 +0200

hildon-desktop (1:2.0.2-2) sardine; urgency=low

  * debian/config/applications.menu: added modest to the application menu.
  Fixes: NB#74333

 -- Johan Bilien <johan.bilien@nokia.com>  Fri, 26 Oct 2007 11:28:59 +0300

## hildon-desktop 2.0.11

=== test/minihome/Makefile ===
# This file is part of hildon-desktop
#
# Copyright (c) 2006 Nokia Corporation. All rights reserved.
#
# Contact: Karoliina Salminen <karoliina.t.salminen@nokia.com>
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
# 02110-1301 USA
#

ALL: minihome

CPP_FLAGS+=-I../../src

hildon-home-select-applets-dialog.o: hildon-home-select-applets-dialog.c hildon-home-select-applets-dialog.h
	gcc $(CPP_FLAGS)-Wall -Werror -g -o hildon-home-select-applets-dialog.o -c hildon-home-select-applets-dialog.c `pkg-config --cflags libhildondesktop`

minihome: minihome.c hildon-home-select-applets-dialog.o
	gcc $(LD_FLAGS) $(CPP_FLAGS)-Wall -Werror -g -o minihome minihome.c hildon-home-select-applets-dialog.o `pkg-config --libs --cflags libhildondesktop`
